using DataFrames, Gadfly
df = readtable("/Users/Matthieu/Dropbox/Github/FixedEffectModels.jl/benchmark/benchmark.csv")

df[:R] = df[:R] ./ df[:Julia]
df[:Stata] = df[:Stata] ./ df[:Julia]
df[:Julia] = df[:Julia] ./ df[:Julia]

mdf = melt(df[[:Command, :Julia, :R, :Stata]], :Command)
mdf = rename(mdf, :variable => :Language)
p = plot(mdf, x = "Language", y = "value", color = "Command", Guide.ylabel("Relative Time (seconds)"), Guide.xlabel("Model"), Scale.y_log10)

draw(SVG("result.svg", 8inch, 5inch), p)
